/*Canopy - The next generation of stoner streaming software
Copyright (C) 2024  Rainbownapkin and the TTN Community

This program is free software: you can redistribute it and/or modify
it under the terms of the GNU Affero General Public License as
published by the Free Software Foundation, either version 3 of the
License, or (at your option) any later version.

This program is distributed in the hope that it will be useful,
but WITHOUT ANY WARRANTY; without even the implied warranty of
MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
GNU Affero General Public License for more details.

You should have received a copy of the GNU Affero General Public License
along with this program.  If not, see <https://www.gnu.org/licenses/>.*/

//npm imports
const { Router } = require('express');

//local imports
const accountValidator = require("../../validators/accountValidator");
const loginController = require("../../controllers/api/account/loginController");
const logoutController = require("../../controllers/api/account/logoutController");
const registerController = require("../../controllers/api/account/registerController");
const updateController = require("../../controllers/api/account/updateController");
const rankEnumController = require("../../controllers/api/account/rankEnumController");
const deleteController = require("../../controllers/api/account/deleteController");

//globals
const router = Router();

//routing functions
router.post('/login', accountValidator.user(), accountValidator.pass(), loginController.post);

router.get('/logout', logoutController.get);

router.post('/register', accountValidator.user(),
    accountValidator.pass(),
    accountValidator.pass('passConfirm'),
    accountValidator.email(), registerController.post);

router.post('/update', accountValidator.img(),
    accountValidator.bio(),
    accountValidator.signature(),
    accountValidator.pass('passChange.oldPass'),
    accountValidator.securePass('passChange.newPass'),
    accountValidator.pass('passChange.confirmPass'), updateController.post);

//This might seem silly, but it allows us to cleanly get the current rank list to compare against, without storing it in multiple places
router.get('/rankEnum', rankEnumController.get);

router.post('/delete', accountValidator.pass(), deleteController.post);

module.exports = router;